﻿// <auto-generated> This file has been auto generated by EF Core Power Tools. </auto-generated>
using Microsoft.Data.SqlClient;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using TEC.DAL.Models;

namespace TEC.DAL.Models
{
    public partial class DB_PRUEBA_TECNICAContext
    {
        private IDB_PRUEBA_TECNICAContextProcedures _procedures;

        public virtual IDB_PRUEBA_TECNICAContextProcedures Procedures
        {
            get
            {
                if (_procedures is null) _procedures = new DB_PRUEBA_TECNICAContextProcedures(this);
                return _procedures;
            }
            set
            {
                _procedures = value;
            }
        }

        public IDB_PRUEBA_TECNICAContextProcedures GetProcedures()
        {
            return Procedures;
        }

        protected void OnModelCreatingGeneratedProcedures(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<PRO_APP_USUARIOS_CONSULTAR_PAGINADOResult>().HasNoKey().ToView(null);
            modelBuilder.Entity<PRO_APP_USUARIOS_CONSULTAR_TODOSResult>().HasNoKey().ToView(null);
        }
    }

    public partial class DB_PRUEBA_TECNICAContextProcedures : IDB_PRUEBA_TECNICAContextProcedures
    {
        private readonly DB_PRUEBA_TECNICAContext _context;

        public DB_PRUEBA_TECNICAContextProcedures(DB_PRUEBA_TECNICAContext context)
        {
            _context = context;
        }

        public virtual async Task<int> PRO_APP_USUARIOS_ACTUALIZACIONAsync(string Nombre, DateTime? Fecha_Nacimiento, string Sexo, OutputParameter<int> Respuesta = null, OutputParameter<int> returnValue = null, CancellationToken cancellationToken = default)
        {
            var parameterreturnValue = new SqlParameter
            {
                ParameterName = "returnValue",
                Direction = System.Data.ParameterDirection.Output,
                SqlDbType = System.Data.SqlDbType.Int,
            };

            var sqlParameters = new []
            {
                new SqlParameter
                {
                    ParameterName = "Nombre",
                    Size = 100,
                    Value = Nombre ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.VarChar,
                },
                new SqlParameter
                {
                    ParameterName = "Fecha_Nacimiento",
                    Value = Fecha_Nacimiento ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.Date,
                },
                new SqlParameter
                {
                    ParameterName = "Sexo",
                    Size = 1,
                    Value = Sexo ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.Char,
                },
                parameterreturnValue,
            };
            var sql = "EXEC [dbo].[PRO_APP_USUARIOS_ACTUALIZACION] @Nombre, @Fecha_Nacimiento, @Sexo, @Respuesta OUTPUT";

            var respuestaParameter = new SqlParameter
            {
                ParameterName = "@Respuesta",
                Direction = System.Data.ParameterDirection.Output,
                Value = Respuesta ?? Convert.DBNull,
                SqlDbType = System.Data.SqlDbType.Int
            };

            sqlParameters = sqlParameters.Concat(new[] { respuestaParameter }).ToArray();

            var _ = await _context.Database.ExecuteSqlRawAsync(sql, sqlParameters, cancellationToken);

            returnValue?.SetValue(parameterreturnValue.Value);

            var respuestax= (int)respuestaParameter.Value;

            return respuestax;
        }

        public virtual async Task<List<PRO_APP_USUARIOS_CONSULTAR_PAGINADOResult>> PRO_APP_USUARIOS_CONSULTAR_PAGINADOAsync(int? Numero_Pagina, int? Cantidad_Por_Pagina, OutputParameter<int> Cantidad_Total = null, OutputParameter<int> Numero_Pagina_Maximo = null, OutputParameter<int> returnValue = null, CancellationToken cancellationToken = default)
        {
            var parameterCantidad_Total = new SqlParameter
            {
                ParameterName = "Cantidad_Total",
                Direction = System.Data.ParameterDirection.InputOutput,
                Value = Cantidad_Total?._value ?? Convert.DBNull,
                SqlDbType = System.Data.SqlDbType.Int,
            };
            var parameterNumero_Pagina_Maximo = new SqlParameter
            {
                ParameterName = "Numero_Pagina_Maximo",
                Direction = System.Data.ParameterDirection.InputOutput,
                Value = Numero_Pagina_Maximo?._value ?? Convert.DBNull,
                SqlDbType = System.Data.SqlDbType.Int,
            };
            var parameterreturnValue = new SqlParameter
            {
                ParameterName = "returnValue",
                Direction = System.Data.ParameterDirection.Output,
                SqlDbType = System.Data.SqlDbType.Int,
            };

            var sqlParameters = new []
            {
                new SqlParameter
                {
                    ParameterName = "Numero_Pagina",
                    Value = Numero_Pagina ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.Int,
                },
                new SqlParameter
                {
                    ParameterName = "Cantidad_Por_Pagina",
                    Value = Cantidad_Por_Pagina ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.Int,
                },
                parameterCantidad_Total,
                parameterNumero_Pagina_Maximo,
                parameterreturnValue,
            };
            var _ = await _context.SqlQueryAsync<PRO_APP_USUARIOS_CONSULTAR_PAGINADOResult>("EXEC @returnValue = [dbo].[PRO_APP_USUARIOS_CONSULTAR_PAGINADO] @Numero_Pagina, @Cantidad_Por_Pagina, @Cantidad_Total OUTPUT, @Numero_Pagina_Maximo OUTPUT", sqlParameters, cancellationToken);

            Cantidad_Total.SetValue(parameterCantidad_Total.Value);
            Numero_Pagina_Maximo.SetValue(parameterNumero_Pagina_Maximo.Value);
            returnValue?.SetValue(parameterreturnValue.Value);

            return _;
        }

        public virtual async Task<List<PRO_APP_USUARIOS_CONSULTAR_TODOSResult>> PRO_APP_USUARIOS_CONSULTAR_TODOSAsync(OutputParameter<int> returnValue = null, CancellationToken cancellationToken = default)
        {
            var parameterreturnValue = new SqlParameter
            {
                ParameterName = "returnValue",
                Direction = System.Data.ParameterDirection.Output,
                SqlDbType = System.Data.SqlDbType.Int,
            };

            var sqlParameters = new []
            {
                parameterreturnValue,
            };
            var _ = await _context.SqlQueryAsync<PRO_APP_USUARIOS_CONSULTAR_TODOSResult>("EXEC @returnValue = [dbo].[PRO_APP_USUARIOS_CONSULTAR_TODOS]", sqlParameters, cancellationToken);

            returnValue?.SetValue(parameterreturnValue.Value);

            return _;
        }

        public virtual async Task<int> PRO_APP_USUARIOS_ELIMINACIONAsync(string Nombre, OutputParameter<int> Respuesta = null, OutputParameter<int> returnValue = null, CancellationToken cancellationToken = default)
        {
            var parameterreturnValue = new SqlParameter
            {
                ParameterName = "returnValue",
                Direction = System.Data.ParameterDirection.Output,
                SqlDbType = System.Data.SqlDbType.Int,
            };

            var sqlParameters = new[]
            {
                new SqlParameter
                {
                    ParameterName = "Nombre",
                    Size = 100,
                    Value = Nombre ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.VarChar,
                },
                parameterreturnValue,
            };

            var sql = "EXEC [dbo].[PRO_APP_USUARIOS_ELIMINACION] @Nombre, @Respuesta OUTPUT";

            var respuestaParameter = new SqlParameter
            {
                ParameterName = "@Respuesta",
                Direction = System.Data.ParameterDirection.Output,
                Value = Respuesta ?? Convert.DBNull,
                SqlDbType = System.Data.SqlDbType.Int
            };

            sqlParameters = sqlParameters.Concat(new[] { respuestaParameter }).ToArray();

            var _ = await _context.Database.ExecuteSqlRawAsync(sql, sqlParameters, cancellationToken);

            returnValue?.SetValue(parameterreturnValue.Value);

            var respuestax= (int)respuestaParameter.Value;

            return respuestax;
        }

        public virtual async Task<int> PRO_APP_USUARIOS_INSERCIONAsync(string Nombre, DateTime? Fecha_Nacimiento, string Sexo, OutputParameter<int> Respuesta = null, OutputParameter<int> returnValue = null, CancellationToken cancellationToken = default)
        {
            var parameterreturnValue = new SqlParameter
            {
                ParameterName = "returnValue",
                Direction = System.Data.ParameterDirection.Output,
                SqlDbType = System.Data.SqlDbType.Int,
            };

            var sqlParameters = new []
            {
                new SqlParameter
                {
                    ParameterName = "Nombre",
                    Size = 100,
                    Value = Nombre ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.VarChar,
                },
                new SqlParameter
                {
                    ParameterName = "Fecha_Nacimiento",
                    Value = Fecha_Nacimiento ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.Date,
                },
                new SqlParameter
                {
                    ParameterName = "Sexo",
                    Size = 1,
                    Value = Sexo ?? Convert.DBNull,
                    SqlDbType = System.Data.SqlDbType.Char,
                },
                parameterreturnValue,
            };
            var sql = "EXEC [dbo].[PRO_APP_USUARIOS_INSERCION] @Nombre, @Fecha_Nacimiento, @Sexo, @Respuesta OUTPUT";

            var respuestaParameter = new SqlParameter
            {
                ParameterName = "@Respuesta",
                Direction = System.Data.ParameterDirection.Output,
                Value = Respuesta ?? Convert.DBNull,
                SqlDbType = System.Data.SqlDbType.Int
            };

            sqlParameters = sqlParameters.Concat(new[] { respuestaParameter }).ToArray();

            var _ = await _context.Database.ExecuteSqlRawAsync(sql, sqlParameters, cancellationToken);

            returnValue?.SetValue(parameterreturnValue.Value);

            var respuestax = (int)respuestaParameter.Value;

            return respuestax;
        }
    }
}
